/*******************************************************************************
 * FoxActivateItemUI generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxActivateItemUI extends FoxUIBaseTransactionTask within FoxUI;

var transient array<InventoryMetaData> InventoryItems;
var transient array<StoreMetaData> StoreItems;
var transient bool bShowWorkingDialog;
var transient bool bEquip;
var private transient bool bHasWorkingDialog;
var transient string ConfirmActivateMessage;
var private transient string CachedInputString;
var private const localized string LocErrorUnsupported;
var private const localized string LocConfirmActivate;
var private const localized string LocActivating;
var private const localized string LocActivatingCaps;
var delegate<PostActivateItem> __PostActivateItem__Delegate;
var delegate<CancelActivateItem> __CancelActivateItem__Delegate;

delegate PostActivateItem(bool bSuccess, bool bShouldEquip)
{
    //return;    
}

delegate CancelActivateItem()
{
    //return;    
}

function bool ActivateItem(optional bool bForceActivate)
{
    bForceActivate = false;
    // End:0x31
    if(StartTask())
    {
        PreActivateItem(((bForceActivate) ? 0 : 1));
        return true;
    }
    return false;
    //return ReturnValue;    
}

protected function RegisterOnlineDelegates()
{
    Outer.PCOwner.OnlineSub.StoreInterface.AddActivateItemCompleteDelegate(0, ActivateItemComplete);
    //return;    
}

protected function CleanupOnlineDelegates()
{
    Outer.PCOwner.OnlineSub.StoreInterface.ClearActivateItemCompleteDelegate(0, ActivateItemComplete);
    //return;    
}

protected function PeekFront(optional out InventoryMetaData InventoryItem, optional out StoreMetaData StoreItem)
{
    // End:0x4E
    if((InventoryItems.Length > 0) && StoreItems.Length > 0)
    {
        InventoryItem = InventoryItems[0];
        StoreItem = StoreItems[0];
    }
    //return;    
}

protected function PopFront(optional out InventoryMetaData InventoryItem, optional out StoreMetaData StoreItem)
{
    // End:0x5A
    if((InventoryItems.Length > 0) && StoreItems.Length > 0)
    {
        PeekFront(InventoryItem, StoreItem);
        InventoryItems.Remove(0, 1);
        StoreItems.Remove(0, 1);
    }
    //return;    
}

protected function NotifyProcessComplete(FoxDialogBoxBase.EDialogBoxConfirmType Selection)
{
    OnWorkingDialogHide();
    bHasWorkingDialog = false;
    super(FoxUIBaseTask).NotifyProcessComplete(Selection);
    PostActivateItem(Selection == 0, bEquip);
    //return;    
}

protected function NotifyProcessFailed(FoxDialogBoxBase.EDialogBoxConfirmType Selection)
{
    // End:0x35
    if((Selection == 0) && InventoryItems.Length > 0)
    {
        PreActivateItem(0);
    }
    // End:0x48
    else
    {
        super(FoxUIBaseTask).NotifyProcessFailed(Selection);
    }
    //return;    
}

protected function bool ValidateActivateItem(out string ErrorText, const out InventoryMetaData InventoryItem, const out StoreMetaData StoreItem)
{
    // End:0x7E
    if((InventoryItem.InstanceId == "") || InventoryItem.ItemId != StoreItems[0].ItemId)
    {
        RetrievePurchaseResult(2, ErrorText);
        return false;
    }
    // End:0xBE
    else
    {
        // End:0xBE
        if(!IsActivationSupported(StoreItem.ActivationType))
        {
            ErrorText = LocErrorUnsupported;
            return false;
        }
    }
    return true;
    //return ReturnValue;    
}

protected function PreActivateItem(FoxDialogBoxBase.EDialogBoxConfirmType Selection)
{
    local DialogBoxProperties Properties;
    local StoreMetaData StoreItem;
    local InventoryMetaData InventoryItem;

    // End:0x50
    if((InventoryItems.Length == 0) || StoreItems.Length == 0)
    {
        Outer.CloseDialogBox();
        NotifyProcessComplete(0);
    }
    // End:0x36B
    else
    {
        PeekFront(InventoryItem, StoreItem);
        // End:0xE7
        if(!ValidateActivateItem(Properties.BodyText, InventoryItem, StoreItem))
        {
            PopFront();
            ActivateItemFailed(Properties.BodyText, InventoryItem);
        }
        // End:0x36B
        else
        {
            switch(StoreItem.ActivationType)
            {
                // End:0x112
                case 0:
                // End:0x117
                case 3:
                // End:0x17F
                case 4:
                    // End:0x13E
                    if(Selection == 0)
                    {
                        ConfirmActivateItemIntent(0);
                        return;
                    }
                    switch(StoreItem.ItemId)
                    {
                        // End:0x176
                        case 77:
                            DirtyMyStats();
                            // End:0x17C
                            break;
                        // End:0xFFFF
                        default:
                            // End:0x17C
                            break;
                    }
                    // End:0x26E
                    break;
                // End:0x26B
                case 2:
                    Outer.CloseDialogBox();
                    bHasWorkingDialog = false;
                    switch(StoreItem.ItemId)
                    {
                        // End:0x21D
                        case 71:
                            Outer.ChangeName(ActivateItemInputString, ConfirmActivateItemIntent);
                            return;
                        // End:0x265
                        case 74:
                            Outer.RegisterClan(ActivateItemInputString, ConfirmActivateItemIntent);
                            return;
                        // End:0xFFFF
                        default:
                            // End:0x26E
                            break;
                }
                // End:0xFFFF
                default:
                    Properties.DialogType = 2;
                    Properties.TitleText = Outer.LocConfirmLabel;
                    Properties.BodyText = ((ConfirmActivateMessage == "") ? LocConfirmActivate : ConfirmActivateMessage);
                    Properties.OnDialogButtonPressed = ConfirmActivateItemIntent;
                    bHasWorkingDialog = false;
                    Outer.ShowDialogBox(Properties);
                }
            }
            //return;            
}

private final function DirtyMyStats()
{
    local string UpdateString;

    UpdateString = "last_update";
    FoxDataStore_OnlineStats(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxLeaderboard')).StatsRead.SetNamedFloatStat(Outer.PCOwner.PlayerReplicationInfo.UniqueId, UpdateString, 0.0);
    //return;    
}

protected function ConfirmActivateItemIntent(FoxDialogBoxBase.EDialogBoxConfirmType Selection)
{
    local DialogBoxProperties Properties;
    local string ActivationData;

    // End:0x276
    if(Selection == 0)
    {
        ActivationData = GetActivationData(StoreItems[0].ItemId, Outer.PCOwner, CachedInputString);
        Outer.ui_toggleCaptureInput(false);
        // End:0x129
        if(!Outer.PCOwner.OnlineSub.StoreInterface.ActivateItem(InventoryItems[0].InstanceId, ActivationData))
        {
            ActivateItemComplete(false, 11);
        }
        // End:0x273
        else
        {
            // End:0x273
            if(bShowWorkingDialog && !bHasWorkingDialog)
            {
                bHasWorkingDialog = true;
                // End:0x18D
                if(__OnWorkingDialogShow__Delegate != none)
                {
                    OnWorkingDialogShow(LocActivatingCaps);
                    bShowWorkingDialog = false;
                }
                // End:0x273
                else
                {
                    Properties.DialogType = 0;
                    Properties.TitleText = Outer.LocWorkingLabel;
                    Properties.BodyText = LocActivating;
                    Properties.bShowTimer = true;
                    Properties.bCloseOnButtonPress = false;
                    Outer.ShowDialogBox(Properties);
                }
            }
        }
    }
    // End:0x2B4
    else
    {
        NotifyProcessComplete(1);
        Outer.CloseDialogBox();
        CancelActivateItem();
    }
    //return;    
}

protected function ActivateItemInputString(string InputString)
{
    CachedInputString = InputString;
    //return;    
}

protected function ActivateItemComplete(const bool bResult, const Engine.OnlineSubsystemTypes.EPurchaseResult PurchaseResult)
{
    local DialogBoxProperties Properties;
    local InventoryMetaData InventoryItem;
    local string ErrorText;

    Outer.ui_toggleCaptureInput(true);
    // End:0x1C1
    if(InventoryItems.Length > 0)
    {
        PopFront(InventoryItem);
        // End:0x189
        if(bResult)
        {
            Outer.CloseDialogBox();
            Properties.DialogType = 1;
            Properties.TitleText = Outer.LocSuccessLabel;
            Properties.OnDialogButtonPressed = PreActivateItem;
            GetUpdatedItemList(Properties, InventoryItem.InstanceId);
            // End:0x17A
            if(Properties.DialogType != 1)
            {
                Outer.ShowDialogBox(Properties);
            }
            // End:0x186
            else
            {
                PreActivateItem(0);
            }
        }
        // End:0x1C1
        else
        {
            RetrievePurchaseResult(PurchaseResult, ErrorText);
            ActivateItemFailed(ErrorText, InventoryItem);
        }
    }
    //return;    
}

private final function ActivateItemFailed(string ErrorText, const out InventoryMetaData InventoryItem)
{
    local DialogBoxProperties Properties;

    Properties.DialogType = ((InventoryItems.Length > 0) ? 2 : 1);
    Properties.TitleText = Outer.LocFailureLabel;
    Properties.BodyText = ErrorText;
    Properties.InventoryItem = InventoryItem;
    Properties.OnDialogButtonPressed = NotifyProcessFailed;
    bHasWorkingDialog = false;
    Outer.ShowDialogBox(Properties);
    //return;    
}

defaultproperties
{
    bShowWorkingDialog=true
    LocErrorUnsupported="Unable to activate item of unsupported activation type."
    LocConfirmActivate="Are you sure you would like to activate the selected items?"
    LocActivating="Activating items..."
    LocActivatingCaps="ACTIVATING ITEMS..."
    PurchaseResultLabels(0)="Unable to activate invalid inventory item."
    PurchaseResultLabels(1)="Unable to activate item for invalid duration."
    PurchaseResultLabels(2)="Unable to activate item; you already have the maximum number active."
    PurchaseResultLabels(3)="Unable to activate item for unknown reason."
    ActivationResultLabels(0)="Items activated successfully. It can be found in your inventory and equipped."
    ActivationResultLabels(1)="Items activated and consumed successfully."
    ActivationResultLabels(2)="Items activated and consumed successfully."
    ActivationResultLabels(3)="Items activated and consumed successfully."
}